<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/scaler.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('scaler_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">scaler.h</div></div>
</div><!--header-->
<div class="contents">
<a href="scaler_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">* @file scaler.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">* @brief File containing declaration of the scaler classes.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;vector&gt;</span>       <span class="comment">// std::vector</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;string&gt;</span>       <span class="comment">// std::string</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;memory&gt;</span>       <span class="comment">// std::unique_ptr, std::make_unique</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;unordered_map&gt;</span>    <span class="comment">// std::unordered_map</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &quot;<a class="code" href="exceptions_8h.html">exceptions.h</a>&quot;</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="foldopen" id="foldopen00031" data-start="{" data-end="};">
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">   31</a></span>    <span class="keyword">enum</span> <a class="code hl_enumeration" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">SCALER_TYPE</a> {</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">   32</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">IDENTITY</a> = 0,           </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf">   33</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf">MINMAX</a>,                 </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62">   34</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62">STANDARD</a>,               </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    };</div>
</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="foldopen" id="foldopen00041" data-start="{" data-end="};">
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229ce">   41</a></span>    <span class="keyword">enum</span> <a class="code hl_enumeration" href="namespacemelon.html#a7c96133788161408370e83766fc229ce">SCALER_PARAMETER</a> {</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309">   42</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309">LOWER_BOUNDS</a> = 0,       </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b">   43</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b">UPPER_BOUNDS</a>,           </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4">   44</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4">STD_DEV</a>,                </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db">   45</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db">MEAN</a>,                   </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f">   46</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f">SCALED_LOWER_BOUNDS</a>,    </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        <a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32">SCALED_UPPER_BOUNDS</a>     </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32">   48</a></span>    };</div>
</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="foldopen" id="foldopen00054" data-start="{" data-end="};">
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="structmelon_1_1_scaler_data.html">   54</a></span>    <span class="keyword">struct </span><a class="code hl_struct" href="structmelon_1_1_scaler_data.html">ScalerData</a> {</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="structmelon_1_1_scaler_data.html#a37dc498fe4c7d97963aaf3f05eecbd01">   55</a></span>        <a class="code hl_function" href="structmelon_1_1_scaler_data.html#a37dc498fe4c7d97963aaf3f05eecbd01">ScalerData</a>(): <a class="code hl_variable" href="structmelon_1_1_scaler_data.html#ac620f2a8c41a84eb20dbd85c689cddb4">type</a>(<a class="code hl_enumeration" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">SCALER_TYPE</a>::<a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">IDENTITY</a>) {};</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno"><a class="line" href="structmelon_1_1_scaler_data.html#ac620f2a8c41a84eb20dbd85c689cddb4">   56</a></span>        <a class="code hl_enumeration" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">SCALER_TYPE</a> <a class="code hl_variable" href="structmelon_1_1_scaler_data.html#ac620f2a8c41a84eb20dbd85c689cddb4">type</a>;                                                       </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="structmelon_1_1_scaler_data.html#a21b3752024d615cad4135270bac8d4f8">   57</a></span>        std::unordered_map&lt;SCALER_PARAMETER, std::vector&lt;double&gt;&gt; <a class="code hl_variable" href="structmelon_1_1_scaler_data.html#a21b3752024d615cad4135270bac8d4f8">parameters</a>;   </div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>    };</div>
</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00065" data-start="{" data-end="};">
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler.html">   65</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_scaler.html">Scaler</a> {</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler.html#ac098737ac814b791fa4f82dc5278468b">   74</a></span>        <span class="keyword">virtual</span> std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_scaler.html#ac098737ac814b791fa4f82dc5278468b">scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const</span> = 0;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler.html#acc1ba354a08076af07295b7b95ddf139">   83</a></span>        <span class="keyword">virtual</span> std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_scaler.html#acc1ba354a08076af07295b7b95ddf139">descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const</span> = 0;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler.html#a630a4449ca458ff02cc69e32f9c25960">   89</a></span>        <span class="keyword">virtual</span> <a class="code hl_function" href="classmelon_1_1_scaler.html#a630a4449ca458ff02cc69e32f9c25960">~Scaler</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    };</div>
</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00097" data-start="{" data-end="};">
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler_factory.html">   97</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_scaler_factory.html">ScalerFactory</a> {</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span> </div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <span class="keyword">static</span> std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">create_scaler</a>(<span class="keyword">const</span> std::shared_ptr&lt;const ScalerData&gt; scalerData);</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>    };</div>
</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00115" data-start="{" data-end="};">
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="classmelon_1_1_identity_scaler.html">  115</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_identity_scaler.html">IdentityScaler</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_scaler.html">Scaler</a>&lt;T&gt; {</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno"><a class="line" href="classmelon_1_1_identity_scaler.html#af0a9ab64ab0270821f1d009faaa66565">  117</a></span>        <a class="code hl_function" href="classmelon_1_1_identity_scaler.html#af0a9ab64ab0270821f1d009faaa66565">IdentityScaler</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno"><a class="line" href="classmelon_1_1_identity_scaler.html#afc69a84ccbded718a1b8c39c3f358933">  118</a></span>        <a class="code hl_function" href="classmelon_1_1_identity_scaler.html#afc69a84ccbded718a1b8c39c3f358933">~IdentityScaler</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno"><a class="line" href="classmelon_1_1_identity_scaler.html#a94216e6334e78f99af99aa493ebd3a0c">  127</a></span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_identity_scaler.html#a94216e6334e78f99af99aa493ebd3a0c">scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> input; };</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno"><a class="line" href="classmelon_1_1_identity_scaler.html#a59da1a53d947d4be17777524a3120d43">  136</a></span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_identity_scaler.html#a59da1a53d947d4be17777524a3120d43">descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const override </span>{ <span class="keywordflow">return</span> input; };</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    };</div>
</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00144" data-start="{" data-end="};">
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html">  144</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_min_max_scaler.html">MinMaxScaler</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_scaler.html">Scaler</a>&lt;T&gt; {</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#a4692dd7c3dab76d4e189060a4bd494ca">  146</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#a4692dd7c3dab76d4e189060a4bd494ca">_lowerBounds</a>;</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#ac2d9d43ded890a37679f876fb9213a35">  147</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#ac2d9d43ded890a37679f876fb9213a35">_upperBounds</a>;</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span> </div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#a40116fba518d7fff221d0ecc364c5631">  149</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#a40116fba518d7fff221d0ecc364c5631">_scaledLowerBounds</a>;</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#aa1908e8c3d60cf316eedb75869bf6bcb">  150</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#aa1908e8c3d60cf316eedb75869bf6bcb">_scaledUpperBounds</a>;</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#a10f2bd5aaa731136d7089afdf4cad3ed">  153</a></span>        <a class="code hl_function" href="classmelon_1_1_min_max_scaler.html#a10f2bd5aaa731136d7089afdf4cad3ed">MinMaxScaler</a>(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; lowerBounds, <span class="keyword">const</span> std::vector&lt;double&gt;&amp; upperBounds, <span class="keyword">const</span> std::vector&lt;double&gt;&amp; scaledLowerBounds, <span class="keyword">const</span> std::vector&lt;double&gt;&amp; scaledUpperBounds) : <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#a4692dd7c3dab76d4e189060a4bd494ca">_lowerBounds</a>(lowerBounds), <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#ac2d9d43ded890a37679f876fb9213a35">_upperBounds</a>(upperBounds), <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#a40116fba518d7fff221d0ecc364c5631">_scaledLowerBounds</a>(scaledLowerBounds), <a class="code hl_variable" href="classmelon_1_1_min_max_scaler.html#aa1908e8c3d60cf316eedb75869bf6bcb">_scaledUpperBounds</a>(scaledUpperBounds) {};</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_min_max_scaler.html#a82a108230095d1cbdfbb90e221d51cf4">scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span> </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_min_max_scaler.html#afe53d7d2569c3b06f52547a940846a98">descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>    };</div>
</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span> </div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00179" data-start="{" data-end="};">
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html">  179</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_standard_scaler.html">StandardScaler</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_scaler.html">Scaler</a>&lt;T&gt; {</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html#a0f535a7405baecfb7a3c3ab41494872d">  181</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_standard_scaler.html#a0f535a7405baecfb7a3c3ab41494872d">_mean</a>;</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html#ac34dd7674c62dcb2c33925ffeafd810b">  182</a></span>        std::vector&lt;double&gt; <a class="code hl_variable" href="classmelon_1_1_standard_scaler.html#ac34dd7674c62dcb2c33925ffeafd810b">_stdDev</a>;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html#aa24965025a22213f80a98392b21f2f7c">  184</a></span>        <a class="code hl_function" href="classmelon_1_1_standard_scaler.html#aa24965025a22213f80a98392b21f2f7c">StandardScaler</a>(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; mean, <span class="keyword">const</span> std::vector&lt;double&gt;&amp; stdDev) : <a class="code hl_variable" href="classmelon_1_1_standard_scaler.html#a0f535a7405baecfb7a3c3ab41494872d">_mean</a>(mean), <a class="code hl_variable" href="classmelon_1_1_standard_scaler.html#ac34dd7674c62dcb2c33925ffeafd810b">_stdDev</a>(stdDev) {};</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_standard_scaler.html#adbd404ec388534902787f3018e2becfd">scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_standard_scaler.html#a8afb1da58f6717f5b3900567fc82d841">descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>    };</div>
</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>    <span class="comment">// Factory function for creating a instance of a scaler object.</span></div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00208" data-start="{" data-end="}">
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno"><a class="line" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">  208</a></span>    std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">ScalerFactory&lt;T&gt;::create_scaler</a>(<span class="keyword">const</span> std::shared_ptr&lt;const ScalerData&gt; scalerData) {</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        <span class="keywordflow">try</span> {</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>            <span class="keywordflow">switch</span> (scalerData-&gt;type) {</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">SCALER_TYPE::IDENTITY</a>:</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>                <span class="keywordflow">return</span> std::make_unique&lt;IdentityScaler&lt;T&gt;&gt;();</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>            <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf">SCALER_TYPE::MINMAX</a>:</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>                <span class="keywordflow">return</span> std::make_unique&lt;MinMaxScaler&lt;T&gt;&gt;(scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309">SCALER_PARAMETER::LOWER_BOUNDS</a>), scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b">SCALER_PARAMETER::UPPER_BOUNDS</a>), scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f">SCALER_PARAMETER::SCALED_LOWER_BOUNDS</a>), scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32">SCALER_PARAMETER::SCALED_UPPER_BOUNDS</a>));</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>            <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62">SCALER_TYPE::STANDARD</a>:</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>                <span class="keywordflow">return</span> std::make_unique&lt;StandardScaler&lt;T&gt;&gt;(scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db">SCALER_PARAMETER::MEAN</a>), scalerData-&gt;parameters.at(<a class="code hl_enumvalue" href="namespacemelon.html#a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4">SCALER_PARAMETER::STD_DEV</a>));</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>            <span class="keywordflow">default</span>:</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>                <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while creating sclaler: Invalid scaler type.&quot;</span>);</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>            }</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        }</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::out_of_range&amp; e) {</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while creating scaler: Scaler data object is missing a parameter.&quot;</span>, e);</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        }</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>    }</div>
</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span> </div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span> </div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>    <span class="comment">// Scales input values using MinMax-Scaling.</span></div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00230" data-start="{" data-end="}">
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#a82a108230095d1cbdfbb90e221d51cf4">  230</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_min_max_scaler.html#a82a108230095d1cbdfbb90e221d51cf4">MinMaxScaler&lt;T&gt;::scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        std::vector&lt;T&gt; output(input.size());</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; input.size(); ++i) {</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>            output.at(i) = _scaledLowerBounds.at(i) + (input.at(i) - _lowerBounds.at(i)) / (_upperBounds.at(i) - _lowerBounds.at(i)) * (_scaledUpperBounds.at(i) - _scaledLowerBounds.at(i));</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>        }</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span> </div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        <span class="keywordflow">return</span> output;</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>    }</div>
</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span> </div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>    <span class="comment">// Decales input values using MinMax-Scaling.</span></div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00243" data-start="{" data-end="}">
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno"><a class="line" href="classmelon_1_1_min_max_scaler.html#afe53d7d2569c3b06f52547a940846a98">  243</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_min_max_scaler.html#afe53d7d2569c3b06f52547a940846a98">MinMaxScaler&lt;T&gt;::descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        std::vector&lt;T&gt; output(input.size());</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; input.size(); ++i) {</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>            output.at(i) = _lowerBounds.at(i) + (input.at(i) - _scaledLowerBounds.at(i)) / (_scaledUpperBounds.at(i) - _scaledLowerBounds.at(i)) * (_upperBounds.at(i) - _lowerBounds.at(i));</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        }</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        </div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        <span class="keywordflow">return</span> output;</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>    }</div>
</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span> </div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span> </div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>    <span class="comment">// Scales input values using Standard-Scaling.</span></div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00256" data-start="{" data-end="}">
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html#adbd404ec388534902787f3018e2becfd">  256</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_standard_scaler.html#adbd404ec388534902787f3018e2becfd">StandardScaler&lt;T&gt;::scale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>        std::vector&lt;T&gt; output(input.size());</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; input.size(); ++i) {</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>            output.at(i) = (input.at(i) - _mean.at(i)) / _stdDev.at(i);</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>        }</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span> </div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>        <span class="keywordflow">return</span> output;</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>    }</div>
</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span> </div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>    <span class="comment">// Descales input values using Standard-Scaling.</span></div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span> </div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span> </div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00271" data-start="{" data-end="}">
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno"><a class="line" href="classmelon_1_1_standard_scaler.html#a8afb1da58f6717f5b3900567fc82d841">  271</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_standard_scaler.html#a8afb1da58f6717f5b3900567fc82d841">StandardScaler&lt;T&gt;::descale</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; input)<span class="keyword"> const </span>{</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>        std::vector&lt;T&gt; output(input.size());</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; input.size(); ++i) {</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>            output.at(i) = _stdDev.at(i)*input.at(i) + _mean.at(i);</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>        }</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span> </div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>        <span class="keywordflow">return</span> output;</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>    }</div>
</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>}</div>
<div class="ttc" id="aclass_melon_exception_html"><div class="ttname"><a href="class_melon_exception.html">MelonException</a></div><div class="ttdoc">This class defines the exceptions thrown by FeedForwardNet.</div><div class="ttdef"><b>Definition</b> exceptions.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_identity_scaler_html"><div class="ttname"><a href="classmelon_1_1_identity_scaler.html">melon::IdentityScaler</a></div><div class="ttdoc">Class implementing an identity scaling algorithm.</div><div class="ttdef"><b>Definition</b> scaler.h:115</div></div>
<div class="ttc" id="aclassmelon_1_1_identity_scaler_html_a59da1a53d947d4be17777524a3120d43"><div class="ttname"><a href="classmelon_1_1_identity_scaler.html#a59da1a53d947d4be17777524a3120d43">melon::IdentityScaler::descale</a></div><div class="ttdeci">std::vector&lt; T &gt; descale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Scales input values (= no scaling).</div><div class="ttdef"><b>Definition</b> scaler.h:136</div></div>
<div class="ttc" id="aclassmelon_1_1_identity_scaler_html_a94216e6334e78f99af99aa493ebd3a0c"><div class="ttname"><a href="classmelon_1_1_identity_scaler.html#a94216e6334e78f99af99aa493ebd3a0c">melon::IdentityScaler::scale</a></div><div class="ttdeci">std::vector&lt; T &gt; scale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Scales input value using the identity (= no scaling).</div><div class="ttdef"><b>Definition</b> scaler.h:127</div></div>
<div class="ttc" id="aclassmelon_1_1_identity_scaler_html_af0a9ab64ab0270821f1d009faaa66565"><div class="ttname"><a href="classmelon_1_1_identity_scaler.html#af0a9ab64ab0270821f1d009faaa66565">melon::IdentityScaler::IdentityScaler</a></div><div class="ttdeci">IdentityScaler()=default</div></div>
<div class="ttc" id="aclassmelon_1_1_identity_scaler_html_afc69a84ccbded718a1b8c39c3f358933"><div class="ttname"><a href="classmelon_1_1_identity_scaler.html#afc69a84ccbded718a1b8c39c3f358933">melon::IdentityScaler::~IdentityScaler</a></div><div class="ttdeci">~IdentityScaler()=default</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html">melon::MinMaxScaler</a></div><div class="ttdoc">Class implementing a MinMax-Scaling algorithm.</div><div class="ttdef"><b>Definition</b> scaler.h:144</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_a10f2bd5aaa731136d7089afdf4cad3ed"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#a10f2bd5aaa731136d7089afdf4cad3ed">melon::MinMaxScaler::MinMaxScaler</a></div><div class="ttdeci">MinMaxScaler(const std::vector&lt; double &gt; &amp;lowerBounds, const std::vector&lt; double &gt; &amp;upperBounds, const std::vector&lt; double &gt; &amp;scaledLowerBounds, const std::vector&lt; double &gt; &amp;scaledUpperBounds)</div><div class="ttdef"><b>Definition</b> scaler.h:153</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_a40116fba518d7fff221d0ecc364c5631"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#a40116fba518d7fff221d0ecc364c5631">melon::MinMaxScaler::_scaledLowerBounds</a></div><div class="ttdeci">std::vector&lt; double &gt; _scaledLowerBounds</div><div class="ttdef"><b>Definition</b> scaler.h:149</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_a4692dd7c3dab76d4e189060a4bd494ca"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#a4692dd7c3dab76d4e189060a4bd494ca">melon::MinMaxScaler::_lowerBounds</a></div><div class="ttdeci">std::vector&lt; double &gt; _lowerBounds</div><div class="ttdef"><b>Definition</b> scaler.h:146</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_a82a108230095d1cbdfbb90e221d51cf4"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#a82a108230095d1cbdfbb90e221d51cf4">melon::MinMaxScaler::scale</a></div><div class="ttdeci">std::vector&lt; T &gt; scale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Scales input values using MinMax-Scaling.</div><div class="ttdef"><b>Definition</b> scaler.h:230</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_aa1908e8c3d60cf316eedb75869bf6bcb"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#aa1908e8c3d60cf316eedb75869bf6bcb">melon::MinMaxScaler::_scaledUpperBounds</a></div><div class="ttdeci">std::vector&lt; double &gt; _scaledUpperBounds</div><div class="ttdef"><b>Definition</b> scaler.h:150</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_ac2d9d43ded890a37679f876fb9213a35"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#ac2d9d43ded890a37679f876fb9213a35">melon::MinMaxScaler::_upperBounds</a></div><div class="ttdeci">std::vector&lt; double &gt; _upperBounds</div><div class="ttdef"><b>Definition</b> scaler.h:147</div></div>
<div class="ttc" id="aclassmelon_1_1_min_max_scaler_html_afe53d7d2569c3b06f52547a940846a98"><div class="ttname"><a href="classmelon_1_1_min_max_scaler.html#afe53d7d2569c3b06f52547a940846a98">melon::MinMaxScaler::descale</a></div><div class="ttdeci">std::vector&lt; T &gt; descale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Descales input values using MinMax-Scaling.</div><div class="ttdef"><b>Definition</b> scaler.h:243</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_factory_html"><div class="ttname"><a href="classmelon_1_1_scaler_factory.html">melon::ScalerFactory</a></div><div class="ttdoc">This class is a factory class for creating child instances of Scaler.</div><div class="ttdef"><b>Definition</b> scaler.h:97</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_factory_html_a269bf924a7c0cbafe35d32857655cb9c"><div class="ttname"><a href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">melon::ScalerFactory::create_scaler</a></div><div class="ttdeci">static std::unique_ptr&lt; Scaler&lt; T &gt; &gt; create_scaler(const std::shared_ptr&lt; const ScalerData &gt; scalerData)</div><div class="ttdoc">Factory function for creating a instance of a scaler object.</div><div class="ttdef"><b>Definition</b> scaler.h:208</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_html"><div class="ttname"><a href="classmelon_1_1_scaler.html">melon::Scaler</a></div><div class="ttdoc">Abstract class defining scaling algorithm.</div><div class="ttdef"><b>Definition</b> scaler.h:65</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_html_a630a4449ca458ff02cc69e32f9c25960"><div class="ttname"><a href="classmelon_1_1_scaler.html#a630a4449ca458ff02cc69e32f9c25960">melon::Scaler::~Scaler</a></div><div class="ttdeci">virtual ~Scaler()=default</div><div class="ttdoc">Virtual desctructor to enable inheritance.</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_html_ac098737ac814b791fa4f82dc5278468b"><div class="ttname"><a href="classmelon_1_1_scaler.html#ac098737ac814b791fa4f82dc5278468b">melon::Scaler::scale</a></div><div class="ttdeci">virtual std::vector&lt; T &gt; scale(const std::vector&lt; T &gt; &amp;input) const =0</div><div class="ttdoc">Scales input values.</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_html_acc1ba354a08076af07295b7b95ddf139"><div class="ttname"><a href="classmelon_1_1_scaler.html#acc1ba354a08076af07295b7b95ddf139">melon::Scaler::descale</a></div><div class="ttdeci">virtual std::vector&lt; T &gt; descale(const std::vector&lt; T &gt; &amp;input) const =0</div><div class="ttdoc">Descales input values.</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html">melon::StandardScaler</a></div><div class="ttdoc">Class implementing a Standard-Scaling algorithm.</div><div class="ttdef"><b>Definition</b> scaler.h:179</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html_a0f535a7405baecfb7a3c3ab41494872d"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html#a0f535a7405baecfb7a3c3ab41494872d">melon::StandardScaler::_mean</a></div><div class="ttdeci">std::vector&lt; double &gt; _mean</div><div class="ttdef"><b>Definition</b> scaler.h:181</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html_a8afb1da58f6717f5b3900567fc82d841"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html#a8afb1da58f6717f5b3900567fc82d841">melon::StandardScaler::descale</a></div><div class="ttdeci">std::vector&lt; T &gt; descale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Descales input values using Standard-Scaling.</div><div class="ttdef"><b>Definition</b> scaler.h:271</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html_aa24965025a22213f80a98392b21f2f7c"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html#aa24965025a22213f80a98392b21f2f7c">melon::StandardScaler::StandardScaler</a></div><div class="ttdeci">StandardScaler(const std::vector&lt; double &gt; &amp;mean, const std::vector&lt; double &gt; &amp;stdDev)</div><div class="ttdef"><b>Definition</b> scaler.h:184</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html_ac34dd7674c62dcb2c33925ffeafd810b"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html#ac34dd7674c62dcb2c33925ffeafd810b">melon::StandardScaler::_stdDev</a></div><div class="ttdeci">std::vector&lt; double &gt; _stdDev</div><div class="ttdef"><b>Definition</b> scaler.h:182</div></div>
<div class="ttc" id="aclassmelon_1_1_standard_scaler_html_adbd404ec388534902787f3018e2becfd"><div class="ttname"><a href="classmelon_1_1_standard_scaler.html#adbd404ec388534902787f3018e2becfd">melon::StandardScaler::scale</a></div><div class="ttdeci">std::vector&lt; T &gt; scale(const std::vector&lt; T &gt; &amp;input) const override</div><div class="ttdoc">Scales input values using Standard-Scaling.</div><div class="ttdef"><b>Definition</b> scaler.h:256</div></div>
<div class="ttc" id="aexceptions_8h_html"><div class="ttname"><a href="exceptions_8h.html">exceptions.h</a></div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229ce"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229ce">melon::SCALER_PARAMETER</a></div><div class="ttdeci">SCALER_PARAMETER</div><div class="ttdef"><b>Definition</b> scaler.h:41</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db">melon::MEAN</a></div><div class="ttdeci">@ MEAN</div><div class="ttdef"><b>Definition</b> scaler.h:45</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f">melon::SCALED_LOWER_BOUNDS</a></div><div class="ttdeci">@ SCALED_LOWER_BOUNDS</div><div class="ttdef"><b>Definition</b> scaler.h:46</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32">melon::SCALED_UPPER_BOUNDS</a></div><div class="ttdeci">@ SCALED_UPPER_BOUNDS</div><div class="ttdef"><b>Definition</b> scaler.h:47</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4">melon::STD_DEV</a></div><div class="ttdeci">@ STD_DEV</div><div class="ttdef"><b>Definition</b> scaler.h:44</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b">melon::UPPER_BOUNDS</a></div><div class="ttdeci">@ UPPER_BOUNDS</div><div class="ttdef"><b>Definition</b> scaler.h:43</div></div>
<div class="ttc" id="anamespacemelon_html_a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309"><div class="ttname"><a href="namespacemelon.html#a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309">melon::LOWER_BOUNDS</a></div><div class="ttdeci">@ LOWER_BOUNDS</div><div class="ttdef"><b>Definition</b> scaler.h:42</div></div>
<div class="ttc" id="anamespacemelon_html_a7ee65995944832d7b450202201d45c11"><div class="ttname"><a href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">melon::SCALER_TYPE</a></div><div class="ttdeci">SCALER_TYPE</div><div class="ttdoc">Enum for representing the available types of scalers.</div><div class="ttdef"><b>Definition</b> scaler.h:31</div></div>
<div class="ttc" id="anamespacemelon_html_a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf"><div class="ttname"><a href="namespacemelon.html#a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf">melon::MINMAX</a></div><div class="ttdeci">@ MINMAX</div><div class="ttdef"><b>Definition</b> scaler.h:33</div></div>
<div class="ttc" id="anamespacemelon_html_a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62"><div class="ttname"><a href="namespacemelon.html#a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62">melon::STANDARD</a></div><div class="ttdeci">@ STANDARD</div><div class="ttdef"><b>Definition</b> scaler.h:34</div></div>
<div class="ttc" id="anamespacemelon_html_a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3"><div class="ttname"><a href="namespacemelon.html#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">melon::IDENTITY</a></div><div class="ttdeci">@ IDENTITY</div><div class="ttdef"><b>Definition</b> scaler.h:32</div></div>
<div class="ttc" id="astructmelon_1_1_scaler_data_html"><div class="ttname"><a href="structmelon_1_1_scaler_data.html">melon::ScalerData</a></div><div class="ttdoc">Base struct from which data structs of different scalers can be derived.</div><div class="ttdef"><b>Definition</b> scaler.h:54</div></div>
<div class="ttc" id="astructmelon_1_1_scaler_data_html_a21b3752024d615cad4135270bac8d4f8"><div class="ttname"><a href="structmelon_1_1_scaler_data.html#a21b3752024d615cad4135270bac8d4f8">melon::ScalerData::parameters</a></div><div class="ttdeci">std::unordered_map&lt; SCALER_PARAMETER, std::vector&lt; double &gt; &gt; parameters</div><div class="ttdef"><b>Definition</b> scaler.h:57</div></div>
<div class="ttc" id="astructmelon_1_1_scaler_data_html_a37dc498fe4c7d97963aaf3f05eecbd01"><div class="ttname"><a href="structmelon_1_1_scaler_data.html#a37dc498fe4c7d97963aaf3f05eecbd01">melon::ScalerData::ScalerData</a></div><div class="ttdeci">ScalerData()</div><div class="ttdef"><b>Definition</b> scaler.h:55</div></div>
<div class="ttc" id="astructmelon_1_1_scaler_data_html_ac620f2a8c41a84eb20dbd85c689cddb4"><div class="ttname"><a href="structmelon_1_1_scaler_data.html#ac620f2a8c41a84eb20dbd85c689cddb4">melon::ScalerData::type</a></div><div class="ttdeci">SCALER_TYPE type</div><div class="ttdef"><b>Definition</b> scaler.h:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="scaler_8h.html">scaler.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
